`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    21:14:10 03/22/2008 
// Design Name: 
// Module Name:    eRAM 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module eRAM(
					hz_mux,
					rst,
					gclk,
					gclk_x,					
					dck_1,
					dck_2,
					adsc_1,
					adsc_2
					
							);
							
//========= ((((((( OOOOOO )))))))========================

//wwwww{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{zwwwwww 
//     |}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}
//wwwwwww{ zw{ zw{ zw{ zw{ zw{ zw{ zw{ zw{ zwwww
//	      |w} |w} |w} |w} |w} |w} |w} |w} |w}	
//wwwwww{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{zwwwww 
//      |}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}
//wwwwwwww{ zw{ zw{ zw{ zw{ zw{ zw{ zw{ zw{ zwwww
//	       |w} |w} |w} |w} |w} |w} |w} |w} |w}	

//========= ((((((( OOOOOO )))))))========================
`define BID  4'h5	
//===================   OO  OO  OO  OO  OO  OO 
	

input		rst;
input		gclk;
input		gclk_x;
input		[7:0]	hz_mux;
output	dck_1;
output	dck_2;	
output	adsc_1;
output	adsc_2;	

//  >><<<------->><<
reg		ndc_a;
reg		ndc_b;				
reg		hz_oe;
//===================   OO  OO  OO  OO  OO  OO 

wire	dck_1;
wire	dck_2;

wire u1_d4;
wire u2_d4;
wire u3_d4;
wire u4_d4;
wire u5_d4;
wire u6_d4;

wire u1_d4x;
wire u2_d4x;
wire u3_d4x;
wire u4_d4x;
wire u5_d4x;
wire u6_d4x;
//===================   OO  OO  OO  OO  OO  OO 

//assign	dck_1 = gclk;
//assign	dck_2 = ~gclk;


//===================   OO  OO  OO  OO  OO  OO 
/*
always @ ( * )
begin
if ( hz_mux[7:4] == `BID )
	begin 
		case ( hz_mux[3:0] )
		4'h0 : begin dck_2 <= u1_d4; dck_1 <= u1_d4x; end
		4'h3 : begin dck_2 <= u2_d4; dck_1 <= u2_d4x; end		
		4'h7 : begin dck_2 <= u3_d4; dck_1 <= u3_d4x; end
		4'h9 : begin dck_2 <= u4_d4; dck_1 <= u4_d4x; end
		4'hA : begin dck_2 <= u5_d4; dck_1 <= u5_d4x; end
		4'hd : begin dck_2 <= u6_d4; dck_1 <= u6_d4x; end
		default: begin  dck_2 <= u1_d4;  dck_1 <= u1_d4x; end	
		endcase
	end
else
	begin
		case ( hz_mux[3:0] )	
		4'h1 : begin dck_2 <= u1_d4; dck_1 <= u1_d4x; end
		4'h2 : begin dck_2 <= u2_d4; dck_1 <= u2_d4x; end		
		4'h4 : begin dck_2 <= u3_d4; dck_1 <= u3_d4x; end
		4'h6 : begin dck_2 <= u4_d4; dck_1 <= u4_d4x; end
		4'hB : begin dck_2 <= u5_d4; dck_1 <= u5_d4x; end
		4'hE : begin dck_2 <= u6_d4; dck_1 <= u6_d4x; end
		default: begin  dck_2 <= u1_d4;  dck_1 <= u1_d4x; end	
		endcase
	end
end
*/
//===================   OO  OO  OO  OO  OO  OO 

always @ ( * )
begin
if ( !rst ) begin hz_oe <= 1'b0; end
else
	begin
	if ( hz_mux[7:4] == `BID )
		hz_oe <= 1'b1;
		else
		hz_oe <= 1'b0;
	end
end

//===================   OO  OO  OO  OO  OO  OO 
assign dck_2 = ( hz_mux[3:0] == 4'h0 && hz_oe  ) ? gclk :
				   ( hz_mux[3:0] == 4'h3 && hz_oe  ) ? u1_d4 :
				   ( hz_mux[3:0] == 4'h7 && hz_oe  ) ? u2_d4 :
				   ( hz_mux[3:0] == 4'h9 && hz_oe  ) ? u3_d4 :
				   ( hz_mux[3:0] == 4'hA && hz_oe  ) ? u4_d4 :
					( hz_mux[3:0] == 4'hC && hz_oe  ) ? u5_d4 :
				   ( hz_mux[3:0] == 4'hE && hz_oe  ) ? u6_d4 : u1_d4 ;

assign dck_1 = ( hz_mux[3:0] == 4'h0 && hz_oe  ) ? gclk_x :
				   ( hz_mux[3:0] == 4'h3 && hz_oe  ) ? u1_d4x :
				   ( hz_mux[3:0] == 4'h7 && hz_oe  ) ? u2_d4x :
				   ( hz_mux[3:0] == 4'h9 && hz_oe  ) ? u3_d4x :
				   ( hz_mux[3:0] == 4'hA && hz_oe  ) ? u4_d4x :
				   ( hz_mux[3:0] == 4'hC && hz_oe  ) ? u5_d4x :					
				   ( hz_mux[3:0] == 4'hE && hz_oe  ) ? u6_d4x : u1_d4x;

					

//===================   OO  OO  OO  OO  OO  OO 
always @ ( negedge rst or posedge dck_2 )
begin
	if ( ! rst ) begin ndc_a <= 1'b0; end
	else
	begin
	ndc_a <= ~ndc_a;
	end
end
//===================   OO  OO  OO  OO  OO  OO 

always @ ( negedge rst or posedge dck_1 )
begin
	if ( ! rst ) begin ndc_b <= 1'b0; end
	else
	begin
	ndc_b <= ~ndc_b;
	end
end
//===================   OO  OO  OO  OO  OO  OO 

assign adsc_1 = ( !ndc_a ) ? 1'b1 : 1'b0 ;
assign adsc_2 = ( !ndc_b ) ? 1'b1 : 1'b0 ;

//========= ((((((( OOOOOO )))))))========================
//========= ((((((( U1 )))))))=========

DIV_4 u1 (
    .rst(rst), 
    .gclk(gclk), 
    .out_d4(u1_d4)
    );
//========= ((((((( U2 )))))))=========

DIV_4 u2 (
    .rst(rst), 
    .gclk(u1_d4), 
    .out_d4(u2_d4)
    );
//========= ((((((( U3 )))))))=========

DIV_4 u3 (
    .rst(rst), 
    .gclk(u2_d4), 
    .out_d4(u3_d4)
    );
//========= ((((((( U4 )))))))=========

DIV_4 u4 (
    .rst(rst), 
    .gclk(u3_d4), 
    .out_d4(u4_d4)
    );	 
//========= ((((((( U5 )))))))=========

DIV_4 u5 (
    .rst(rst), 
    .gclk(u4_d4), 
    .out_d4(u5_d4)
    );
//========= ((((((( U6 )))))))=========

DIV_4 u6 (
    .rst(rst), 
    .gclk(u5_d4), 
    .out_d4(u6_d4)
    );
//========= ((((((( OOOOOO )))))))========================
//========= ((((((( OOOOOO )))))))========================
//========= ((((((( U1x )))))))=========

DIV_4x u1x (
    .rst(rst), 
    .gclk(gclk_x), 
    .out_d4(u1_d4x)
    );
//========= ((((((( U2x )))))))=========

DIV_4x u2x (
    .rst(rst), 
    .gclk(u1_d4x), 
    .out_d4(u2_d4x)
    );
//========= ((((((( U3x )))))))=========

DIV_4x u3x (
    .rst(rst), 
    .gclk(u2_d4x), 
    .out_d4(u3_d4x)
    );
//========= ((((((( U4x )))))))=========

DIV_4x u4x (
    .rst(rst), 
    .gclk(u3_d4x), 
    .out_d4(u4_d4x)
    );	 
//========= ((((((( U5x )))))))=========

DIV_4x u5x (
    .rst(rst), 
    .gclk(u4_d4x), 
    .out_d4(u5_d4x)
    );
//========= ((((((( U6x )))))))=========

DIV_4x u6x (
    .rst(rst), 
    .gclk(u5_d4x), 
    .out_d4(u6_d4x)
    );
//========= ((((((( OOOOOO )))))))========================






	 
endmodule
